\name{buildSemanticArgumentName}
\alias{buildSemanticArgumentName}
\title{
Build semantic argument name
}
\description{
Build a semantic argument name from the suffix you provide.
}
\usage{
buildSemanticArgumentName(suffix_s_1, variableName_s_1 = "x_")
}
\arguments{
  \item{suffix_s_1}{ one \emph{\code{string}} to be used as a suffix. Use
  \code{retrieveDataFactory()$getKnownSuffixes()} to get a \emph{\code{vector}}
  of known suffixes.
}
  \item{variableName_s_1}{ a \emph{\code{string}} that is the variable name you want to use. }
}
\details{
 Know that no checks are done on \bold{\code{suffix_s_1}}. Value you provide will be trusted,
 regular or irregular one.
}
\value{
A single \emph{\code{string}} that is the argument name build from your \bold{\code{variableName_s_1}}
and \bold{\code{suffix_s_1}} values.
}
\author{
\packageAuthor{wyz.code.metaTesting}

Maintainer: \packageMaintainer{wyz.code.metaTesting}
}
\seealso{
Refer to \code{\link{testFunction}}
}
\examples{
# typical example
buildSemanticArgumentName('i') # x_i

buildSemanticArgumentName('ui_1', 'numberOfItems') # numberOfItems_ui_1
}
\keyword{ programming }
\keyword{ utilities }
\concept{ meta testing }
